OpenShot Audio Library | OpenShotAudio: juce::MemoryInputStream Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.2

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::MemoryInputStream Class Reference

`#include <juce_MemoryInputStream.h>`

Inheritance diagram for juce::MemoryInputStream:

## Public Member Functions
| MemoryInputStream (const void *sourceData, size_t sourceDataSize, bool keepInternalCopyOfData)
| MemoryInputStream (const MemoryBlock &data, bool keepInternalCopyOfData)
| MemoryInputStream (MemoryBlock &&blockToTake)
| ~MemoryInputStream () override
const void * | getData () const noexcept
size_t | getDataSize () const noexcept
int64 | getPosition () override
bool | setPosition (int64) override
int64 | getTotalLength () override
bool | isExhausted () override
int | read (void *destBuffer, int maxBytesToRead) override
void | skipNextBytes (int64 numBytesToSkip) override
Public Member Functions inherited from juce::InputStream
virtual | ~InputStream ()=default
virtual int64 | getTotalLength ()=0
int64 | getNumBytesRemaining ()
virtual bool | isExhausted ()=0
virtual int | read (void *destBuffer, int maxBytesToRead)=0
ssize_t | read (void *destBuffer, size_t maxBytesToRead)
virtual char | readByte ()
virtual bool | readBool ()
virtual short | readShort ()
virtual short | readShortBigEndian ()
virtual int | readInt ()
virtual int | readIntBigEndian ()
virtual int64 | readInt64 ()
virtual int64 | readInt64BigEndian ()
virtual float | readFloat ()
virtual float | readFloatBigEndian ()
virtual double | readDouble ()
virtual double | readDoubleBigEndian ()
virtual int | readCompressedInt ()
virtual String | readNextLine ()
virtual String | readString ()
virtual String | readEntireStreamAsString ()
virtual size_t | readIntoMemoryBlock (MemoryBlock &destBlock, ssize_t maxNumBytesToRead=-1)
virtual int64 | getPosition ()=0
virtual bool | setPosition (int64 newPosition)=0
virtual void | skipNextBytes (int64 numBytesToSkip)

## Detailed Description

Allows a block of data to be accessed as a stream.

This can either be used to refer to a shared block of memory, or can make its own internal copy of the data when the MemoryInputStream is created.

Definition at line 35 of file juce_MemoryInputStream.h.

## Constructor & Destructor Documentation

## ◆ MemoryInputStream() [1/3]

juce::MemoryInputStream::MemoryInputStream | ( | const void * | sourceData,
|  | size_t | sourceDataSize,
|  | bool | keepInternalCopyOfData
| ) |  |

Creates a MemoryInputStream.

Parameters

  sourceData | the block of data to use as the stream's source
  sourceDataSize | the number of bytes in the source data block
  keepInternalCopyOfData | if false, the stream will just keep a pointer to the source data, so this data shouldn't be changed for the lifetime of the stream; if this parameter is true, the stream will make its own copy of the data and use that.

Definition at line 26 of file juce_MemoryInputStream.cpp.

## ◆ MemoryInputStream() [2/3]

juce::MemoryInputStream::MemoryInputStream | ( | const MemoryBlock & | data,
|  | bool | keepInternalCopyOfData
| ) |  |

Creates a MemoryInputStream.

Parameters

  data | a block of data to use as the stream's source
  keepInternalCopyOfData | if false, the stream will just keep a reference to the source data, so this data shouldn't be changed for the lifetime of the stream; if this parameter is true, the stream will make its own copy of the data and use that.

Definition at line 37 of file juce_MemoryInputStream.cpp.

## ◆ MemoryInputStream() [3/3]

juce::MemoryInputStream::MemoryInputStream | ( | MemoryBlock && | blockToTake | ) |

Creates a stream by moving from a MemoryBlock.

Definition at line 48 of file juce_MemoryInputStream.cpp.

## ◆ ~MemoryInputStream()

juce::MemoryInputStream::~MemoryInputStream | ( |  | ) |
| override

Destructor.

Definition at line 54 of file juce_MemoryInputStream.cpp.

## Member Function Documentation

## ◆ getData()

const void * juce::MemoryInputStream::getData | ( |  | ) | const
| inlinenoexcept

Returns a pointer to the source data block from which this stream is reading.

Definition at line 72 of file juce_MemoryInputStream.h.

## ◆ getDataSize()

size_t juce::MemoryInputStream::getDataSize | ( |  | ) | const
| inlinenoexcept

Returns the number of bytes of source data in the block from which this stream is reading.

Definition at line 75 of file juce_MemoryInputStream.h.

## ◆ getPosition()

int64 juce::MemoryInputStream::getPosition | ( |  | ) |
| overridevirtual

Returns the offset of the next byte that will be read from the stream.

See also
  setPosition

Implements juce::InputStream.

Definition at line 92 of file juce_MemoryInputStream.cpp.

Referenced by skipNextBytes().

## ◆ getTotalLength()

int64 juce::MemoryInputStream::getTotalLength | ( |  | ) |
| overridevirtual

Returns the total number of bytes available for reading in this stream.

Note that this is the number of bytes available from the start of the stream, not from the current position.

If the size of the stream isn't actually known, this will return -1.

See also
  getNumBytesRemaining

Implements juce::InputStream.

Definition at line 58 of file juce_MemoryInputStream.cpp.

## ◆ isExhausted()

bool juce::MemoryInputStream::isExhausted | ( |  | ) |
| overridevirtual

Returns true if the stream has no more data to read.

Implements juce::InputStream.

Definition at line 81 of file juce_MemoryInputStream.cpp.

## ◆ read()

int juce::MemoryInputStream::read | ( | void * | destBuffer,
|  | int | maxBytesToRead
| ) |  |
| overridevirtual

Reads some data from the stream into a memory buffer.

This is the only read method that subclasses actually need to implement, as the InputStream base class implements the other read methods in terms of this one (although it's often more efficient for subclasses to implement them directly).

Parameters

  destBuffer | the destination buffer for the data. This must not be null.
  maxBytesToRead | the maximum number of bytes to read - make sure the memory block passed in is big enough to contain this many bytes. This value must not be negative.

Returns
  the actual number of bytes that were read, which may be less than maxBytesToRead if the stream is exhausted before it gets that far

Implements juce::InputStream.

Definition at line 63 of file juce_MemoryInputStream.cpp.

## ◆ setPosition()

bool juce::MemoryInputStream::setPosition | ( | int64 | newPosition | ) |
| overridevirtual

Tries to move the current read position of the stream.

The position is an absolute number of bytes from the stream's start.

Some streams might not be able to do this, in which case they should do nothing and return false. Others might be able to manage it by resetting themselves and skipping to the correct position, although this is obviously a bit slow.

Returns
  true if the stream manages to reposition itself correctly

See also
  getPosition

Implements juce::InputStream.

Definition at line 86 of file juce_MemoryInputStream.cpp.

Referenced by skipNextBytes().

## ◆ skipNextBytes()

void juce::MemoryInputStream::skipNextBytes | ( | int64 | numBytesToSkip | ) |
| overridevirtual

Reads and discards a number of bytes from the stream.

Some input streams might implement this more efficiently, but the base class will just keep reading data until the requisite number of bytes have been done. For large skips it may be quicker to call setPosition() with the required position.

Reimplemented from juce::InputStream.

Definition at line 97 of file juce_MemoryInputStream.cpp.

The documentation for this class was generated from the following files:

- juce_MemoryInputStream.h
- juce_MemoryInputStream.cpp